'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

exports.createInjector = createInjector;
exports.createTrackedComponent = createTrackedComponent;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _raf = require('raf');

var _raf2 = _interopRequireDefault(_raf);

var defaultRect = { top: 0, bottom: 0, left: 0, right: 0, width: 0, height: 0 };
exports.defaultRect = defaultRect;
var identity = function identity(x) {
  return x;
};

function createInjector(component) {
  return (function (_React$Component) {
    _inherits(Track, _React$Component);

    _createClass(Track, null, [{
      key: 'propTypes',
      value: { ref: _react2['default'].PropTypes.func,
        children: _react2['default'].PropTypes.func.isRequired,
        formulas: _react2['default'].PropTypes.array },
      enumerable: true
    }, {
      key: 'defaultProps',
      value: { formulas: [identity], component: component },
      enumerable: true
    }]);

    function Track(props) {
      _classCallCheck(this, Track);

      _get(Object.getPrototypeOf(Track.prototype), 'constructor', this).call(this, props);

      var self = this;

      this.DecoratedComponent = (function (_React$Component2) {
        _inherits(_class, _React$Component2);

        function _class() {
          _classCallCheck(this, _class);

          _get(Object.getPrototypeOf(_class.prototype), 'constructor', this).apply(this, arguments);
        }

        _createClass(_class, [{
          key: 'render',
          value: function render() {
            var _props$ref = this.props.ref;
            var ref = _props$ref === undefined ? self.props.ref || identity : _props$ref;

            return _react2['default'].createElement(props.component, _extends({}, self.props, this.props, {
              ref: function (r) {
                return ref(self.nodeRef = r);
              } }));
          }
        }], [{
          key: 'propTypes',
          value: { ref: _react2['default'].PropTypes.func },
          enumerable: true
        }]);

        return _class;
      })(_react2['default'].Component);
      this.state = {};
    }

    _createClass(Track, [{
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps() {
        var node = (0, _reactDom.findDOMNode)(this.nodeRef);
        var rect = node.getBoundingClientRect();
        this.setState({ rect: rect, node: node });
      }
    }, {
      key: 'render',
      value: function render() {
        var _props;

        var _state = this.state;
        var _state$rect = _state.rect;
        var rect = _state$rect === undefined ? defaultRect : _state$rect;
        var _state$node = _state.node;
        var node = _state$node === undefined ? {} : _state$node;

        return (_props = this.props).children.apply(_props, [this.DecoratedComponent].concat(_toConsumableArray(this.props.formulas.map(function (formula) {
          return formula(rect, node);
        }))));
      }
    }]);

    return Track;
  })(_react2['default'].Component);
}

var Track = createInjector('div');

exports.Track = Track;

var TrackDocument = (function (_React$Component3) {
  _inherits(TrackDocument, _React$Component3);

  _createClass(TrackDocument, null, [{
    key: 'propTypes',
    value: { children: _react2['default'].PropTypes.func.isRequired,
      formulas: _react2['default'].PropTypes.array },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: { formulas: [identity] },
    enumerable: true
  }]);

  function TrackDocument(props) {
    _classCallCheck(this, TrackDocument);

    _get(Object.getPrototypeOf(TrackDocument.prototype), 'constructor', this).call(this, props);
    this.state = { rect: null };
  }

  _createClass(TrackDocument, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this = this;

      var cancel = _raf2['default'].cancel;

      var rafId = undefined;

      var update = function update() {
        _this.setState({ rect: document.documentElement.getBoundingClientRect() });
      };

      var handleScroll = function handleScroll(event) {
        cancel(rafId);
        rafId = (0, _raf2['default'])(update);
      };

      window.addEventListener('scroll', handleScroll);

      this.removeScrollHandler = function () {
        cancel(rafId);
        window.removeEventListener('scroll', handleScroll);
      };
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.removeScrollHandler();
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2;

      var rect = this.state.rect;

      var element = typeof document !== 'undefined' && document.documentElement;
      if (!rect) {
        if (element) {
          rect = element.getBoundingClientRect();
        } else {
          rect = defaultRect;
          element = {}; // bah
        }
      }
      return (_props2 = this.props).children.apply(_props2, _toConsumableArray(this.props.formulas.map(function (formula) {
        return formula(rect, element);
      })));
    }
  }]);

  return TrackDocument;
})(_react2['default'].Component);

exports.TrackDocument = TrackDocument;

function createTrackedComponent(component) {
  return (function (_React$Component4) {
    _inherits(Tracked, _React$Component4);

    _createClass(Tracked, null, [{
      key: 'propTypes',
      value: { children: _react2['default'].PropTypes.func.isRequired,
        formulas: _react2['default'].PropTypes.array,
        component: _react2['default'].PropTypes.oneOfType([_react2['default'].PropTypes.element, _react2['default'].PropTypes.string]) },
      enumerable: true
    }, {
      key: 'defaultProps',
      value: { formulas: [identity], component: component },
      enumerable: true
    }]);

    function Tracked(props) {
      _classCallCheck(this, Tracked);

      _get(Object.getPrototypeOf(Tracked.prototype), 'constructor', this).call(this, props);
      this.state = {};
    }

    _createClass(Tracked, [{
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps() {
        var node = (0, _reactDom.findDOMNode)(this.nodeRef);
        var rect = node.getBoundingClientRect();
        this.setState({ rect: rect, node: node });
      }
    }, {
      key: 'render',
      value: function render() {
        var _this2 = this;

        var _state2 = this.state;
        var _state2$rect = _state2.rect;
        var rect = _state2$rect === undefined ? defaultRect : _state2$rect;
        var _state2$node = _state2.node;
        var node = _state2$node === undefined ? {} : _state2$node;
        var props = this.props;

        return _react2['default'].createElement(
          props.component,
          _extends({ ref: function (r) {
              return _this2.nodeRef = r;
            } }, props),
          props.children.apply(props, _toConsumableArray(props.formulas.map(function (formula) {
            return formula(rect, node);
          })))
        );
      }
    }]);

    return Tracked;
  })(_react2['default'].Component);
}

var TrackedDiv = createTrackedComponent('div');
exports.TrackedDiv = TrackedDiv;